// Code generated - DO NOT EDIT.
// This file is a generated binding and any manual changes will be lost.

package contract

import (
	"errors"
	"math/big"
	"strings"

	ethereum "github.com/ethereum/go-ethereum"
	"github.com/ethereum/go-ethereum/accounts/abi"
	"github.com/ethereum/go-ethereum/accounts/abi/bind"
	"github.com/ethereum/go-ethereum/common"
	"github.com/ethereum/go-ethereum/core/types"
	"github.com/ethereum/go-ethereum/event"
)

// Reference imports to suppress errors if they are not otherwise used.
var (
	_ = errors.New
	_ = big.NewInt
	_ = strings.NewReader
	_ = ethereum.NotFound
	_ = bind.Bind
	_ = common.Big1
	_ = types.BloomLookup
	_ = event.NewSubscription
)

// WitnessMetaData contains all meta data concerning the Witness contract.
var WitnessMetaData = &bind.MetaData{
	ABI: "[{\"inputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"constructor\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"owner\",\"type\":\"address\"}],\"name\":\"OwnableInvalidOwner\",\"type\":\"error\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"account\",\"type\":\"address\"}],\"name\":\"OwnableUnauthorizedAccount\",\"type\":\"error\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"dailyDistribution\",\"type\":\"uint256\"}],\"name\":\"DailyDistributionChanged\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"string\",\"name\":\"date\",\"type\":\"string\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"merkleRoot\",\"type\":\"bytes32\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"merkleSumRoot\",\"type\":\"bytes32\"}],\"name\":\"MerkleRootChanged\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"addr\",\"type\":\"address\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"merkleRoot\",\"type\":\"bytes32\"},{\"indexed\":false,\"internalType\":\"bytes32\",\"name\":\"merkleSumRoot\",\"type\":\"bytes32\"},{\"indexed\":true,\"internalType\":\"uint256\",\"name\":\"count\",\"type\":\"uint256\"},{\"indexed\":true,\"internalType\":\"uint256\",\"name\":\"dailySubmitCount\",\"type\":\"uint256\"}],\"name\":\"MerkleRootSubmitted\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":false,\"internalType\":\"uint256\",\"name\":\"merkleRootThreshold\",\"type\":\"uint256\"}],\"name\":\"MerkleRootThresholdChanged\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"previousOwner\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"OwnershipTransferred\",\"type\":\"event\"},{\"anonymous\":false,\"inputs\":[{\"indexed\":true,\"internalType\":\"address\",\"name\":\"addr\",\"type\":\"address\"},{\"indexed\":true,\"internalType\":\"bool\",\"name\":\"ok\",\"type\":\"bool\"},{\"indexed\":true,\"internalType\":\"uint256\",\"name\":\"count\",\"type\":\"uint256\"}],\"name\":\"WitnessChanged\",\"type\":\"event\"},{\"inputs\":[],\"name\":\"dailyDistribution\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"}],\"name\":\"dailyMerkleRootMap\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"dailyMerkleRootSubmitCount\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"},{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"name\":\"dailyMerkleRootSubmitCountMap\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"},{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"dailyMerkleRootSubmittedMap\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"}],\"name\":\"dailyMerkleRootVerifiedMap\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"\",\"type\":\"string\"}],\"name\":\"dailyMerkleSumRootMap\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"getDailyDistribution\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"getMerkleRoot\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"getWitnesses\",\"outputs\":[{\"internalType\":\"address[]\",\"name\":\"\",\"type\":\"address[]\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"addr\",\"type\":\"address\"}],\"name\":\"isWitness\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"lastMerkleRootUpdate\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"merkleRoot\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"merkleRootThreshold\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"merkleSumRoot\",\"outputs\":[{\"internalType\":\"bytes32\",\"name\":\"\",\"type\":\"bytes32\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"owner\",\"outputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"renounceOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_dailyDistribution\",\"type\":\"uint256\"}],\"name\":\"setDailyDistribution\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"uint256\",\"name\":\"_merkleRootThreshold\",\"type\":\"uint256\"}],\"name\":\"setRootThreshold\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"addr\",\"type\":\"address\"},{\"internalType\":\"bool\",\"name\":\"ok\",\"type\":\"bool\"}],\"name\":\"setWitness\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"string\",\"name\":\"_date\",\"type\":\"string\"},{\"internalType\":\"bytes32\",\"name\":\"_merkleRoot\",\"type\":\"bytes32\"},{\"internalType\":\"bytes32\",\"name\":\"_merkleSumRoot\",\"type\":\"bytes32\"}],\"name\":\"submitMerkleRoot\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"newOwner\",\"type\":\"address\"}],\"name\":\"transferOwnership\",\"outputs\":[],\"stateMutability\":\"nonpayable\",\"type\":\"function\"},{\"inputs\":[{\"internalType\":\"address\",\"name\":\"\",\"type\":\"address\"}],\"name\":\"witnessAddressMap\",\"outputs\":[{\"internalType\":\"bool\",\"name\":\"\",\"type\":\"bool\"}],\"stateMutability\":\"view\",\"type\":\"function\"},{\"inputs\":[],\"name\":\"witnessCount\",\"outputs\":[{\"internalType\":\"uint256\",\"name\":\"\",\"type\":\"uint256\"}],\"stateMutability\":\"view\",\"type\":\"function\"}]",
}

// WitnessABI is the input ABI used to generate the binding from.
// Deprecated: Use WitnessMetaData.ABI instead.
var WitnessABI = WitnessMetaData.ABI

// Witness is an auto generated Go binding around an Ethereum contract.
type Witness struct {
	WitnessCaller     // Read-only binding to the contract
	WitnessTransactor // Write-only binding to the contract
	WitnessFilterer   // Log filterer for contract events
}

// WitnessCaller is an auto generated read-only Go binding around an Ethereum contract.
type WitnessCaller struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// WitnessTransactor is an auto generated write-only Go binding around an Ethereum contract.
type WitnessTransactor struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// WitnessFilterer is an auto generated log filtering Go binding around an Ethereum contract events.
type WitnessFilterer struct {
	contract *bind.BoundContract // Generic contract wrapper for the low level calls
}

// WitnessSession is an auto generated Go binding around an Ethereum contract,
// with pre-set call and transact options.
type WitnessSession struct {
	Contract     *Witness          // Generic contract binding to set the session for
	CallOpts     bind.CallOpts     // Call options to use throughout this session
	TransactOpts bind.TransactOpts // Transaction auth options to use throughout this session
}

// WitnessCallerSession is an auto generated read-only Go binding around an Ethereum contract,
// with pre-set call options.
type WitnessCallerSession struct {
	Contract *WitnessCaller // Generic contract caller binding to set the session for
	CallOpts bind.CallOpts  // Call options to use throughout this session
}

// WitnessTransactorSession is an auto generated write-only Go binding around an Ethereum contract,
// with pre-set transact options.
type WitnessTransactorSession struct {
	Contract     *WitnessTransactor // Generic contract transactor binding to set the session for
	TransactOpts bind.TransactOpts  // Transaction auth options to use throughout this session
}

// WitnessRaw is an auto generated low-level Go binding around an Ethereum contract.
type WitnessRaw struct {
	Contract *Witness // Generic contract binding to access the raw methods on
}

// WitnessCallerRaw is an auto generated low-level read-only Go binding around an Ethereum contract.
type WitnessCallerRaw struct {
	Contract *WitnessCaller // Generic read-only contract binding to access the raw methods on
}

// WitnessTransactorRaw is an auto generated low-level write-only Go binding around an Ethereum contract.
type WitnessTransactorRaw struct {
	Contract *WitnessTransactor // Generic write-only contract binding to access the raw methods on
}

// NewWitness creates a new instance of Witness, bound to a specific deployed contract.
func NewWitness(address common.Address, backend bind.ContractBackend) (*Witness, error) {
	contract, err := bindWitness(address, backend, backend, backend)
	if err != nil {
		return nil, err
	}
	return &Witness{WitnessCaller: WitnessCaller{contract: contract}, WitnessTransactor: WitnessTransactor{contract: contract}, WitnessFilterer: WitnessFilterer{contract: contract}}, nil
}

// NewWitnessCaller creates a new read-only instance of Witness, bound to a specific deployed contract.
func NewWitnessCaller(address common.Address, caller bind.ContractCaller) (*WitnessCaller, error) {
	contract, err := bindWitness(address, caller, nil, nil)
	if err != nil {
		return nil, err
	}
	return &WitnessCaller{contract: contract}, nil
}

// NewWitnessTransactor creates a new write-only instance of Witness, bound to a specific deployed contract.
func NewWitnessTransactor(address common.Address, transactor bind.ContractTransactor) (*WitnessTransactor, error) {
	contract, err := bindWitness(address, nil, transactor, nil)
	if err != nil {
		return nil, err
	}
	return &WitnessTransactor{contract: contract}, nil
}

// NewWitnessFilterer creates a new log filterer instance of Witness, bound to a specific deployed contract.
func NewWitnessFilterer(address common.Address, filterer bind.ContractFilterer) (*WitnessFilterer, error) {
	contract, err := bindWitness(address, nil, nil, filterer)
	if err != nil {
		return nil, err
	}
	return &WitnessFilterer{contract: contract}, nil
}

// bindWitness binds a generic wrapper to an already deployed contract.
func bindWitness(address common.Address, caller bind.ContractCaller, transactor bind.ContractTransactor, filterer bind.ContractFilterer) (*bind.BoundContract, error) {
	parsed, err := abi.JSON(strings.NewReader(WitnessABI))
	if err != nil {
		return nil, err
	}
	return bind.NewBoundContract(address, parsed, caller, transactor, filterer), nil
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Witness *WitnessRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Witness.Contract.WitnessCaller.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Witness *WitnessRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Witness.Contract.WitnessTransactor.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Witness *WitnessRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Witness.Contract.WitnessTransactor.contract.Transact(opts, method, params...)
}

// Call invokes the (constant) contract method with params as input values and
// sets the output to result. The result type might be a single field for simple
// returns, a slice of interfaces for anonymous returns and a struct for named
// returns.
func (_Witness *WitnessCallerRaw) Call(opts *bind.CallOpts, result *[]interface{}, method string, params ...interface{}) error {
	return _Witness.Contract.contract.Call(opts, result, method, params...)
}

// Transfer initiates a plain transaction to move funds to the contract, calling
// its default method if one is available.
func (_Witness *WitnessTransactorRaw) Transfer(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Witness.Contract.contract.Transfer(opts)
}

// Transact invokes the (paid) contract method with params as input values.
func (_Witness *WitnessTransactorRaw) Transact(opts *bind.TransactOpts, method string, params ...interface{}) (*types.Transaction, error) {
	return _Witness.Contract.contract.Transact(opts, method, params...)
}

// DailyDistribution is a free data retrieval call binding the contract method 0xde8f55af.
//
// Solidity: function dailyDistribution() view returns(uint256)
func (_Witness *WitnessCaller) DailyDistribution(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "dailyDistribution")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// DailyDistribution is a free data retrieval call binding the contract method 0xde8f55af.
//
// Solidity: function dailyDistribution() view returns(uint256)
func (_Witness *WitnessSession) DailyDistribution() (*big.Int, error) {
	return _Witness.Contract.DailyDistribution(&_Witness.CallOpts)
}

// DailyDistribution is a free data retrieval call binding the contract method 0xde8f55af.
//
// Solidity: function dailyDistribution() view returns(uint256)
func (_Witness *WitnessCallerSession) DailyDistribution() (*big.Int, error) {
	return _Witness.Contract.DailyDistribution(&_Witness.CallOpts)
}

// DailyMerkleRootMap is a free data retrieval call binding the contract method 0x933c2732.
//
// Solidity: function dailyMerkleRootMap(string ) view returns(bytes32)
func (_Witness *WitnessCaller) DailyMerkleRootMap(opts *bind.CallOpts, arg0 string) ([32]byte, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "dailyMerkleRootMap", arg0)

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// DailyMerkleRootMap is a free data retrieval call binding the contract method 0x933c2732.
//
// Solidity: function dailyMerkleRootMap(string ) view returns(bytes32)
func (_Witness *WitnessSession) DailyMerkleRootMap(arg0 string) ([32]byte, error) {
	return _Witness.Contract.DailyMerkleRootMap(&_Witness.CallOpts, arg0)
}

// DailyMerkleRootMap is a free data retrieval call binding the contract method 0x933c2732.
//
// Solidity: function dailyMerkleRootMap(string ) view returns(bytes32)
func (_Witness *WitnessCallerSession) DailyMerkleRootMap(arg0 string) ([32]byte, error) {
	return _Witness.Contract.DailyMerkleRootMap(&_Witness.CallOpts, arg0)
}

// DailyMerkleRootSubmitCount is a free data retrieval call binding the contract method 0xeb6dd75e.
//
// Solidity: function dailyMerkleRootSubmitCount() view returns(uint256)
func (_Witness *WitnessCaller) DailyMerkleRootSubmitCount(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "dailyMerkleRootSubmitCount")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// DailyMerkleRootSubmitCount is a free data retrieval call binding the contract method 0xeb6dd75e.
//
// Solidity: function dailyMerkleRootSubmitCount() view returns(uint256)
func (_Witness *WitnessSession) DailyMerkleRootSubmitCount() (*big.Int, error) {
	return _Witness.Contract.DailyMerkleRootSubmitCount(&_Witness.CallOpts)
}

// DailyMerkleRootSubmitCount is a free data retrieval call binding the contract method 0xeb6dd75e.
//
// Solidity: function dailyMerkleRootSubmitCount() view returns(uint256)
func (_Witness *WitnessCallerSession) DailyMerkleRootSubmitCount() (*big.Int, error) {
	return _Witness.Contract.DailyMerkleRootSubmitCount(&_Witness.CallOpts)
}

// DailyMerkleRootSubmitCountMap is a free data retrieval call binding the contract method 0x1ff9cbaa.
//
// Solidity: function dailyMerkleRootSubmitCountMap(string , bytes32 ) view returns(uint256)
func (_Witness *WitnessCaller) DailyMerkleRootSubmitCountMap(opts *bind.CallOpts, arg0 string, arg1 [32]byte) (*big.Int, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "dailyMerkleRootSubmitCountMap", arg0, arg1)

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// DailyMerkleRootSubmitCountMap is a free data retrieval call binding the contract method 0x1ff9cbaa.
//
// Solidity: function dailyMerkleRootSubmitCountMap(string , bytes32 ) view returns(uint256)
func (_Witness *WitnessSession) DailyMerkleRootSubmitCountMap(arg0 string, arg1 [32]byte) (*big.Int, error) {
	return _Witness.Contract.DailyMerkleRootSubmitCountMap(&_Witness.CallOpts, arg0, arg1)
}

// DailyMerkleRootSubmitCountMap is a free data retrieval call binding the contract method 0x1ff9cbaa.
//
// Solidity: function dailyMerkleRootSubmitCountMap(string , bytes32 ) view returns(uint256)
func (_Witness *WitnessCallerSession) DailyMerkleRootSubmitCountMap(arg0 string, arg1 [32]byte) (*big.Int, error) {
	return _Witness.Contract.DailyMerkleRootSubmitCountMap(&_Witness.CallOpts, arg0, arg1)
}

// DailyMerkleRootSubmittedMap is a free data retrieval call binding the contract method 0x9b6c4c33.
//
// Solidity: function dailyMerkleRootSubmittedMap(string , address ) view returns(bool)
func (_Witness *WitnessCaller) DailyMerkleRootSubmittedMap(opts *bind.CallOpts, arg0 string, arg1 common.Address) (bool, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "dailyMerkleRootSubmittedMap", arg0, arg1)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// DailyMerkleRootSubmittedMap is a free data retrieval call binding the contract method 0x9b6c4c33.
//
// Solidity: function dailyMerkleRootSubmittedMap(string , address ) view returns(bool)
func (_Witness *WitnessSession) DailyMerkleRootSubmittedMap(arg0 string, arg1 common.Address) (bool, error) {
	return _Witness.Contract.DailyMerkleRootSubmittedMap(&_Witness.CallOpts, arg0, arg1)
}

// DailyMerkleRootSubmittedMap is a free data retrieval call binding the contract method 0x9b6c4c33.
//
// Solidity: function dailyMerkleRootSubmittedMap(string , address ) view returns(bool)
func (_Witness *WitnessCallerSession) DailyMerkleRootSubmittedMap(arg0 string, arg1 common.Address) (bool, error) {
	return _Witness.Contract.DailyMerkleRootSubmittedMap(&_Witness.CallOpts, arg0, arg1)
}

// DailyMerkleRootVerifiedMap is a free data retrieval call binding the contract method 0x0b89bee2.
//
// Solidity: function dailyMerkleRootVerifiedMap(string ) view returns(bool)
func (_Witness *WitnessCaller) DailyMerkleRootVerifiedMap(opts *bind.CallOpts, arg0 string) (bool, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "dailyMerkleRootVerifiedMap", arg0)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// DailyMerkleRootVerifiedMap is a free data retrieval call binding the contract method 0x0b89bee2.
//
// Solidity: function dailyMerkleRootVerifiedMap(string ) view returns(bool)
func (_Witness *WitnessSession) DailyMerkleRootVerifiedMap(arg0 string) (bool, error) {
	return _Witness.Contract.DailyMerkleRootVerifiedMap(&_Witness.CallOpts, arg0)
}

// DailyMerkleRootVerifiedMap is a free data retrieval call binding the contract method 0x0b89bee2.
//
// Solidity: function dailyMerkleRootVerifiedMap(string ) view returns(bool)
func (_Witness *WitnessCallerSession) DailyMerkleRootVerifiedMap(arg0 string) (bool, error) {
	return _Witness.Contract.DailyMerkleRootVerifiedMap(&_Witness.CallOpts, arg0)
}

// DailyMerkleSumRootMap is a free data retrieval call binding the contract method 0x61bc5c39.
//
// Solidity: function dailyMerkleSumRootMap(string ) view returns(bytes32)
func (_Witness *WitnessCaller) DailyMerkleSumRootMap(opts *bind.CallOpts, arg0 string) ([32]byte, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "dailyMerkleSumRootMap", arg0)

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// DailyMerkleSumRootMap is a free data retrieval call binding the contract method 0x61bc5c39.
//
// Solidity: function dailyMerkleSumRootMap(string ) view returns(bytes32)
func (_Witness *WitnessSession) DailyMerkleSumRootMap(arg0 string) ([32]byte, error) {
	return _Witness.Contract.DailyMerkleSumRootMap(&_Witness.CallOpts, arg0)
}

// DailyMerkleSumRootMap is a free data retrieval call binding the contract method 0x61bc5c39.
//
// Solidity: function dailyMerkleSumRootMap(string ) view returns(bytes32)
func (_Witness *WitnessCallerSession) DailyMerkleSumRootMap(arg0 string) ([32]byte, error) {
	return _Witness.Contract.DailyMerkleSumRootMap(&_Witness.CallOpts, arg0)
}

// GetDailyDistribution is a free data retrieval call binding the contract method 0xc75c46c8.
//
// Solidity: function getDailyDistribution() view returns(uint256)
func (_Witness *WitnessCaller) GetDailyDistribution(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "getDailyDistribution")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// GetDailyDistribution is a free data retrieval call binding the contract method 0xc75c46c8.
//
// Solidity: function getDailyDistribution() view returns(uint256)
func (_Witness *WitnessSession) GetDailyDistribution() (*big.Int, error) {
	return _Witness.Contract.GetDailyDistribution(&_Witness.CallOpts)
}

// GetDailyDistribution is a free data retrieval call binding the contract method 0xc75c46c8.
//
// Solidity: function getDailyDistribution() view returns(uint256)
func (_Witness *WitnessCallerSession) GetDailyDistribution() (*big.Int, error) {
	return _Witness.Contract.GetDailyDistribution(&_Witness.CallOpts)
}

// GetMerkleRoot is a free data retrieval call binding the contract method 0x49590657.
//
// Solidity: function getMerkleRoot() view returns(bytes32)
func (_Witness *WitnessCaller) GetMerkleRoot(opts *bind.CallOpts) ([32]byte, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "getMerkleRoot")

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// GetMerkleRoot is a free data retrieval call binding the contract method 0x49590657.
//
// Solidity: function getMerkleRoot() view returns(bytes32)
func (_Witness *WitnessSession) GetMerkleRoot() ([32]byte, error) {
	return _Witness.Contract.GetMerkleRoot(&_Witness.CallOpts)
}

// GetMerkleRoot is a free data retrieval call binding the contract method 0x49590657.
//
// Solidity: function getMerkleRoot() view returns(bytes32)
func (_Witness *WitnessCallerSession) GetMerkleRoot() ([32]byte, error) {
	return _Witness.Contract.GetMerkleRoot(&_Witness.CallOpts)
}

// GetWitnesses is a free data retrieval call binding the contract method 0x96d195bd.
//
// Solidity: function getWitnesses() view returns(address[])
func (_Witness *WitnessCaller) GetWitnesses(opts *bind.CallOpts) ([]common.Address, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "getWitnesses")

	if err != nil {
		return *new([]common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new([]common.Address)).(*[]common.Address)

	return out0, err

}

// GetWitnesses is a free data retrieval call binding the contract method 0x96d195bd.
//
// Solidity: function getWitnesses() view returns(address[])
func (_Witness *WitnessSession) GetWitnesses() ([]common.Address, error) {
	return _Witness.Contract.GetWitnesses(&_Witness.CallOpts)
}

// GetWitnesses is a free data retrieval call binding the contract method 0x96d195bd.
//
// Solidity: function getWitnesses() view returns(address[])
func (_Witness *WitnessCallerSession) GetWitnesses() ([]common.Address, error) {
	return _Witness.Contract.GetWitnesses(&_Witness.CallOpts)
}

// IsWitness is a free data retrieval call binding the contract method 0xfa7643f4.
//
// Solidity: function isWitness(address addr) view returns(bool)
func (_Witness *WitnessCaller) IsWitness(opts *bind.CallOpts, addr common.Address) (bool, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "isWitness", addr)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// IsWitness is a free data retrieval call binding the contract method 0xfa7643f4.
//
// Solidity: function isWitness(address addr) view returns(bool)
func (_Witness *WitnessSession) IsWitness(addr common.Address) (bool, error) {
	return _Witness.Contract.IsWitness(&_Witness.CallOpts, addr)
}

// IsWitness is a free data retrieval call binding the contract method 0xfa7643f4.
//
// Solidity: function isWitness(address addr) view returns(bool)
func (_Witness *WitnessCallerSession) IsWitness(addr common.Address) (bool, error) {
	return _Witness.Contract.IsWitness(&_Witness.CallOpts, addr)
}

// LastMerkleRootUpdate is a free data retrieval call binding the contract method 0xed86955e.
//
// Solidity: function lastMerkleRootUpdate() view returns(uint256)
func (_Witness *WitnessCaller) LastMerkleRootUpdate(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "lastMerkleRootUpdate")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// LastMerkleRootUpdate is a free data retrieval call binding the contract method 0xed86955e.
//
// Solidity: function lastMerkleRootUpdate() view returns(uint256)
func (_Witness *WitnessSession) LastMerkleRootUpdate() (*big.Int, error) {
	return _Witness.Contract.LastMerkleRootUpdate(&_Witness.CallOpts)
}

// LastMerkleRootUpdate is a free data retrieval call binding the contract method 0xed86955e.
//
// Solidity: function lastMerkleRootUpdate() view returns(uint256)
func (_Witness *WitnessCallerSession) LastMerkleRootUpdate() (*big.Int, error) {
	return _Witness.Contract.LastMerkleRootUpdate(&_Witness.CallOpts)
}

// MerkleRoot is a free data retrieval call binding the contract method 0x2eb4a7ab.
//
// Solidity: function merkleRoot() view returns(bytes32)
func (_Witness *WitnessCaller) MerkleRoot(opts *bind.CallOpts) ([32]byte, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "merkleRoot")

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// MerkleRoot is a free data retrieval call binding the contract method 0x2eb4a7ab.
//
// Solidity: function merkleRoot() view returns(bytes32)
func (_Witness *WitnessSession) MerkleRoot() ([32]byte, error) {
	return _Witness.Contract.MerkleRoot(&_Witness.CallOpts)
}

// MerkleRoot is a free data retrieval call binding the contract method 0x2eb4a7ab.
//
// Solidity: function merkleRoot() view returns(bytes32)
func (_Witness *WitnessCallerSession) MerkleRoot() ([32]byte, error) {
	return _Witness.Contract.MerkleRoot(&_Witness.CallOpts)
}

// MerkleRootThreshold is a free data retrieval call binding the contract method 0x63bd80dd.
//
// Solidity: function merkleRootThreshold() view returns(uint256)
func (_Witness *WitnessCaller) MerkleRootThreshold(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "merkleRootThreshold")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// MerkleRootThreshold is a free data retrieval call binding the contract method 0x63bd80dd.
//
// Solidity: function merkleRootThreshold() view returns(uint256)
func (_Witness *WitnessSession) MerkleRootThreshold() (*big.Int, error) {
	return _Witness.Contract.MerkleRootThreshold(&_Witness.CallOpts)
}

// MerkleRootThreshold is a free data retrieval call binding the contract method 0x63bd80dd.
//
// Solidity: function merkleRootThreshold() view returns(uint256)
func (_Witness *WitnessCallerSession) MerkleRootThreshold() (*big.Int, error) {
	return _Witness.Contract.MerkleRootThreshold(&_Witness.CallOpts)
}

// MerkleSumRoot is a free data retrieval call binding the contract method 0x529d7e7c.
//
// Solidity: function merkleSumRoot() view returns(bytes32)
func (_Witness *WitnessCaller) MerkleSumRoot(opts *bind.CallOpts) ([32]byte, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "merkleSumRoot")

	if err != nil {
		return *new([32]byte), err
	}

	out0 := *abi.ConvertType(out[0], new([32]byte)).(*[32]byte)

	return out0, err

}

// MerkleSumRoot is a free data retrieval call binding the contract method 0x529d7e7c.
//
// Solidity: function merkleSumRoot() view returns(bytes32)
func (_Witness *WitnessSession) MerkleSumRoot() ([32]byte, error) {
	return _Witness.Contract.MerkleSumRoot(&_Witness.CallOpts)
}

// MerkleSumRoot is a free data retrieval call binding the contract method 0x529d7e7c.
//
// Solidity: function merkleSumRoot() view returns(bytes32)
func (_Witness *WitnessCallerSession) MerkleSumRoot() ([32]byte, error) {
	return _Witness.Contract.MerkleSumRoot(&_Witness.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Witness *WitnessCaller) Owner(opts *bind.CallOpts) (common.Address, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "owner")

	if err != nil {
		return *new(common.Address), err
	}

	out0 := *abi.ConvertType(out[0], new(common.Address)).(*common.Address)

	return out0, err

}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Witness *WitnessSession) Owner() (common.Address, error) {
	return _Witness.Contract.Owner(&_Witness.CallOpts)
}

// Owner is a free data retrieval call binding the contract method 0x8da5cb5b.
//
// Solidity: function owner() view returns(address)
func (_Witness *WitnessCallerSession) Owner() (common.Address, error) {
	return _Witness.Contract.Owner(&_Witness.CallOpts)
}

// WitnessAddressMap is a free data retrieval call binding the contract method 0xfe88504e.
//
// Solidity: function witnessAddressMap(address ) view returns(bool)
func (_Witness *WitnessCaller) WitnessAddressMap(opts *bind.CallOpts, arg0 common.Address) (bool, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "witnessAddressMap", arg0)

	if err != nil {
		return *new(bool), err
	}

	out0 := *abi.ConvertType(out[0], new(bool)).(*bool)

	return out0, err

}

// WitnessAddressMap is a free data retrieval call binding the contract method 0xfe88504e.
//
// Solidity: function witnessAddressMap(address ) view returns(bool)
func (_Witness *WitnessSession) WitnessAddressMap(arg0 common.Address) (bool, error) {
	return _Witness.Contract.WitnessAddressMap(&_Witness.CallOpts, arg0)
}

// WitnessAddressMap is a free data retrieval call binding the contract method 0xfe88504e.
//
// Solidity: function witnessAddressMap(address ) view returns(bool)
func (_Witness *WitnessCallerSession) WitnessAddressMap(arg0 common.Address) (bool, error) {
	return _Witness.Contract.WitnessAddressMap(&_Witness.CallOpts, arg0)
}

// WitnessCount is a free data retrieval call binding the contract method 0x75aa85c1.
//
// Solidity: function witnessCount() view returns(uint256)
func (_Witness *WitnessCaller) WitnessCount(opts *bind.CallOpts) (*big.Int, error) {
	var out []interface{}
	err := _Witness.contract.Call(opts, &out, "witnessCount")

	if err != nil {
		return *new(*big.Int), err
	}

	out0 := *abi.ConvertType(out[0], new(*big.Int)).(**big.Int)

	return out0, err

}

// WitnessCount is a free data retrieval call binding the contract method 0x75aa85c1.
//
// Solidity: function witnessCount() view returns(uint256)
func (_Witness *WitnessSession) WitnessCount() (*big.Int, error) {
	return _Witness.Contract.WitnessCount(&_Witness.CallOpts)
}

// WitnessCount is a free data retrieval call binding the contract method 0x75aa85c1.
//
// Solidity: function witnessCount() view returns(uint256)
func (_Witness *WitnessCallerSession) WitnessCount() (*big.Int, error) {
	return _Witness.Contract.WitnessCount(&_Witness.CallOpts)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Witness *WitnessTransactor) RenounceOwnership(opts *bind.TransactOpts) (*types.Transaction, error) {
	return _Witness.contract.Transact(opts, "renounceOwnership")
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Witness *WitnessSession) RenounceOwnership() (*types.Transaction, error) {
	return _Witness.Contract.RenounceOwnership(&_Witness.TransactOpts)
}

// RenounceOwnership is a paid mutator transaction binding the contract method 0x715018a6.
//
// Solidity: function renounceOwnership() returns()
func (_Witness *WitnessTransactorSession) RenounceOwnership() (*types.Transaction, error) {
	return _Witness.Contract.RenounceOwnership(&_Witness.TransactOpts)
}

// SetDailyDistribution is a paid mutator transaction binding the contract method 0x2911360a.
//
// Solidity: function setDailyDistribution(uint256 _dailyDistribution) returns()
func (_Witness *WitnessTransactor) SetDailyDistribution(opts *bind.TransactOpts, _dailyDistribution *big.Int) (*types.Transaction, error) {
	return _Witness.contract.Transact(opts, "setDailyDistribution", _dailyDistribution)
}

// SetDailyDistribution is a paid mutator transaction binding the contract method 0x2911360a.
//
// Solidity: function setDailyDistribution(uint256 _dailyDistribution) returns()
func (_Witness *WitnessSession) SetDailyDistribution(_dailyDistribution *big.Int) (*types.Transaction, error) {
	return _Witness.Contract.SetDailyDistribution(&_Witness.TransactOpts, _dailyDistribution)
}

// SetDailyDistribution is a paid mutator transaction binding the contract method 0x2911360a.
//
// Solidity: function setDailyDistribution(uint256 _dailyDistribution) returns()
func (_Witness *WitnessTransactorSession) SetDailyDistribution(_dailyDistribution *big.Int) (*types.Transaction, error) {
	return _Witness.Contract.SetDailyDistribution(&_Witness.TransactOpts, _dailyDistribution)
}

// SetRootThreshold is a paid mutator transaction binding the contract method 0x718b08a8.
//
// Solidity: function setRootThreshold(uint256 _merkleRootThreshold) returns()
func (_Witness *WitnessTransactor) SetRootThreshold(opts *bind.TransactOpts, _merkleRootThreshold *big.Int) (*types.Transaction, error) {
	return _Witness.contract.Transact(opts, "setRootThreshold", _merkleRootThreshold)
}

// SetRootThreshold is a paid mutator transaction binding the contract method 0x718b08a8.
//
// Solidity: function setRootThreshold(uint256 _merkleRootThreshold) returns()
func (_Witness *WitnessSession) SetRootThreshold(_merkleRootThreshold *big.Int) (*types.Transaction, error) {
	return _Witness.Contract.SetRootThreshold(&_Witness.TransactOpts, _merkleRootThreshold)
}

// SetRootThreshold is a paid mutator transaction binding the contract method 0x718b08a8.
//
// Solidity: function setRootThreshold(uint256 _merkleRootThreshold) returns()
func (_Witness *WitnessTransactorSession) SetRootThreshold(_merkleRootThreshold *big.Int) (*types.Transaction, error) {
	return _Witness.Contract.SetRootThreshold(&_Witness.TransactOpts, _merkleRootThreshold)
}

// SetWitness is a paid mutator transaction binding the contract method 0x7643244a.
//
// Solidity: function setWitness(address addr, bool ok) returns()
func (_Witness *WitnessTransactor) SetWitness(opts *bind.TransactOpts, addr common.Address, ok bool) (*types.Transaction, error) {
	return _Witness.contract.Transact(opts, "setWitness", addr, ok)
}

// SetWitness is a paid mutator transaction binding the contract method 0x7643244a.
//
// Solidity: function setWitness(address addr, bool ok) returns()
func (_Witness *WitnessSession) SetWitness(addr common.Address, ok bool) (*types.Transaction, error) {
	return _Witness.Contract.SetWitness(&_Witness.TransactOpts, addr, ok)
}

// SetWitness is a paid mutator transaction binding the contract method 0x7643244a.
//
// Solidity: function setWitness(address addr, bool ok) returns()
func (_Witness *WitnessTransactorSession) SetWitness(addr common.Address, ok bool) (*types.Transaction, error) {
	return _Witness.Contract.SetWitness(&_Witness.TransactOpts, addr, ok)
}

// SubmitMerkleRoot is a paid mutator transaction binding the contract method 0xb51d7c96.
//
// Solidity: function submitMerkleRoot(string _date, bytes32 _merkleRoot, bytes32 _merkleSumRoot) returns()
func (_Witness *WitnessTransactor) SubmitMerkleRoot(opts *bind.TransactOpts, _date string, _merkleRoot [32]byte, _merkleSumRoot [32]byte) (*types.Transaction, error) {
	return _Witness.contract.Transact(opts, "submitMerkleRoot", _date, _merkleRoot, _merkleSumRoot)
}

// SubmitMerkleRoot is a paid mutator transaction binding the contract method 0xb51d7c96.
//
// Solidity: function submitMerkleRoot(string _date, bytes32 _merkleRoot, bytes32 _merkleSumRoot) returns()
func (_Witness *WitnessSession) SubmitMerkleRoot(_date string, _merkleRoot [32]byte, _merkleSumRoot [32]byte) (*types.Transaction, error) {
	return _Witness.Contract.SubmitMerkleRoot(&_Witness.TransactOpts, _date, _merkleRoot, _merkleSumRoot)
}

// SubmitMerkleRoot is a paid mutator transaction binding the contract method 0xb51d7c96.
//
// Solidity: function submitMerkleRoot(string _date, bytes32 _merkleRoot, bytes32 _merkleSumRoot) returns()
func (_Witness *WitnessTransactorSession) SubmitMerkleRoot(_date string, _merkleRoot [32]byte, _merkleSumRoot [32]byte) (*types.Transaction, error) {
	return _Witness.Contract.SubmitMerkleRoot(&_Witness.TransactOpts, _date, _merkleRoot, _merkleSumRoot)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Witness *WitnessTransactor) TransferOwnership(opts *bind.TransactOpts, newOwner common.Address) (*types.Transaction, error) {
	return _Witness.contract.Transact(opts, "transferOwnership", newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Witness *WitnessSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _Witness.Contract.TransferOwnership(&_Witness.TransactOpts, newOwner)
}

// TransferOwnership is a paid mutator transaction binding the contract method 0xf2fde38b.
//
// Solidity: function transferOwnership(address newOwner) returns()
func (_Witness *WitnessTransactorSession) TransferOwnership(newOwner common.Address) (*types.Transaction, error) {
	return _Witness.Contract.TransferOwnership(&_Witness.TransactOpts, newOwner)
}

// WitnessDailyDistributionChangedIterator is returned from FilterDailyDistributionChanged and is used to iterate over the raw logs and unpacked data for DailyDistributionChanged events raised by the Witness contract.
type WitnessDailyDistributionChangedIterator struct {
	Event *WitnessDailyDistributionChanged // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *WitnessDailyDistributionChangedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(WitnessDailyDistributionChanged)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(WitnessDailyDistributionChanged)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *WitnessDailyDistributionChangedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *WitnessDailyDistributionChangedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// WitnessDailyDistributionChanged represents a DailyDistributionChanged event raised by the Witness contract.
type WitnessDailyDistributionChanged struct {
	DailyDistribution *big.Int
	Raw               types.Log // Blockchain specific contextual infos
}

// FilterDailyDistributionChanged is a free log retrieval operation binding the contract event 0xb3ae8e2fdcbd3e5bc919976d8ad797511092f7b991c4a29813a72b0b09e79458.
//
// Solidity: event DailyDistributionChanged(uint256 dailyDistribution)
func (_Witness *WitnessFilterer) FilterDailyDistributionChanged(opts *bind.FilterOpts) (*WitnessDailyDistributionChangedIterator, error) {

	logs, sub, err := _Witness.contract.FilterLogs(opts, "DailyDistributionChanged")
	if err != nil {
		return nil, err
	}
	return &WitnessDailyDistributionChangedIterator{contract: _Witness.contract, event: "DailyDistributionChanged", logs: logs, sub: sub}, nil
}

// WatchDailyDistributionChanged is a free log subscription operation binding the contract event 0xb3ae8e2fdcbd3e5bc919976d8ad797511092f7b991c4a29813a72b0b09e79458.
//
// Solidity: event DailyDistributionChanged(uint256 dailyDistribution)
func (_Witness *WitnessFilterer) WatchDailyDistributionChanged(opts *bind.WatchOpts, sink chan<- *WitnessDailyDistributionChanged) (event.Subscription, error) {

	logs, sub, err := _Witness.contract.WatchLogs(opts, "DailyDistributionChanged")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(WitnessDailyDistributionChanged)
				if err := _Witness.contract.UnpackLog(event, "DailyDistributionChanged", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseDailyDistributionChanged is a log parse operation binding the contract event 0xb3ae8e2fdcbd3e5bc919976d8ad797511092f7b991c4a29813a72b0b09e79458.
//
// Solidity: event DailyDistributionChanged(uint256 dailyDistribution)
func (_Witness *WitnessFilterer) ParseDailyDistributionChanged(log types.Log) (*WitnessDailyDistributionChanged, error) {
	event := new(WitnessDailyDistributionChanged)
	if err := _Witness.contract.UnpackLog(event, "DailyDistributionChanged", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// WitnessMerkleRootChangedIterator is returned from FilterMerkleRootChanged and is used to iterate over the raw logs and unpacked data for MerkleRootChanged events raised by the Witness contract.
type WitnessMerkleRootChangedIterator struct {
	Event *WitnessMerkleRootChanged // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *WitnessMerkleRootChangedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(WitnessMerkleRootChanged)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(WitnessMerkleRootChanged)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *WitnessMerkleRootChangedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *WitnessMerkleRootChangedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// WitnessMerkleRootChanged represents a MerkleRootChanged event raised by the Witness contract.
type WitnessMerkleRootChanged struct {
	Date          string
	MerkleRoot    [32]byte
	MerkleSumRoot [32]byte
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterMerkleRootChanged is a free log retrieval operation binding the contract event 0x03802ed049c84cd4e511bf3c40208130b1c5d73897142ecfb572a739c9e9f06d.
//
// Solidity: event MerkleRootChanged(string date, bytes32 merkleRoot, bytes32 merkleSumRoot)
func (_Witness *WitnessFilterer) FilterMerkleRootChanged(opts *bind.FilterOpts) (*WitnessMerkleRootChangedIterator, error) {

	logs, sub, err := _Witness.contract.FilterLogs(opts, "MerkleRootChanged")
	if err != nil {
		return nil, err
	}
	return &WitnessMerkleRootChangedIterator{contract: _Witness.contract, event: "MerkleRootChanged", logs: logs, sub: sub}, nil
}

// WatchMerkleRootChanged is a free log subscription operation binding the contract event 0x03802ed049c84cd4e511bf3c40208130b1c5d73897142ecfb572a739c9e9f06d.
//
// Solidity: event MerkleRootChanged(string date, bytes32 merkleRoot, bytes32 merkleSumRoot)
func (_Witness *WitnessFilterer) WatchMerkleRootChanged(opts *bind.WatchOpts, sink chan<- *WitnessMerkleRootChanged) (event.Subscription, error) {

	logs, sub, err := _Witness.contract.WatchLogs(opts, "MerkleRootChanged")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(WitnessMerkleRootChanged)
				if err := _Witness.contract.UnpackLog(event, "MerkleRootChanged", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseMerkleRootChanged is a log parse operation binding the contract event 0x03802ed049c84cd4e511bf3c40208130b1c5d73897142ecfb572a739c9e9f06d.
//
// Solidity: event MerkleRootChanged(string date, bytes32 merkleRoot, bytes32 merkleSumRoot)
func (_Witness *WitnessFilterer) ParseMerkleRootChanged(log types.Log) (*WitnessMerkleRootChanged, error) {
	event := new(WitnessMerkleRootChanged)
	if err := _Witness.contract.UnpackLog(event, "MerkleRootChanged", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// WitnessMerkleRootSubmittedIterator is returned from FilterMerkleRootSubmitted and is used to iterate over the raw logs and unpacked data for MerkleRootSubmitted events raised by the Witness contract.
type WitnessMerkleRootSubmittedIterator struct {
	Event *WitnessMerkleRootSubmitted // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *WitnessMerkleRootSubmittedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(WitnessMerkleRootSubmitted)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(WitnessMerkleRootSubmitted)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *WitnessMerkleRootSubmittedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *WitnessMerkleRootSubmittedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// WitnessMerkleRootSubmitted represents a MerkleRootSubmitted event raised by the Witness contract.
type WitnessMerkleRootSubmitted struct {
	Addr             common.Address
	MerkleRoot       [32]byte
	MerkleSumRoot    [32]byte
	Count            *big.Int
	DailySubmitCount *big.Int
	Raw              types.Log // Blockchain specific contextual infos
}

// FilterMerkleRootSubmitted is a free log retrieval operation binding the contract event 0x7c0db56049d8c21ac04eb9f10f3a12460a3cd42c97482ed65838b868f685a34d.
//
// Solidity: event MerkleRootSubmitted(address indexed addr, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 indexed count, uint256 indexed dailySubmitCount)
func (_Witness *WitnessFilterer) FilterMerkleRootSubmitted(opts *bind.FilterOpts, addr []common.Address, count []*big.Int, dailySubmitCount []*big.Int) (*WitnessMerkleRootSubmittedIterator, error) {

	var addrRule []interface{}
	for _, addrItem := range addr {
		addrRule = append(addrRule, addrItem)
	}

	var countRule []interface{}
	for _, countItem := range count {
		countRule = append(countRule, countItem)
	}
	var dailySubmitCountRule []interface{}
	for _, dailySubmitCountItem := range dailySubmitCount {
		dailySubmitCountRule = append(dailySubmitCountRule, dailySubmitCountItem)
	}

	logs, sub, err := _Witness.contract.FilterLogs(opts, "MerkleRootSubmitted", addrRule, countRule, dailySubmitCountRule)
	if err != nil {
		return nil, err
	}
	return &WitnessMerkleRootSubmittedIterator{contract: _Witness.contract, event: "MerkleRootSubmitted", logs: logs, sub: sub}, nil
}

// WatchMerkleRootSubmitted is a free log subscription operation binding the contract event 0x7c0db56049d8c21ac04eb9f10f3a12460a3cd42c97482ed65838b868f685a34d.
//
// Solidity: event MerkleRootSubmitted(address indexed addr, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 indexed count, uint256 indexed dailySubmitCount)
func (_Witness *WitnessFilterer) WatchMerkleRootSubmitted(opts *bind.WatchOpts, sink chan<- *WitnessMerkleRootSubmitted, addr []common.Address, count []*big.Int, dailySubmitCount []*big.Int) (event.Subscription, error) {

	var addrRule []interface{}
	for _, addrItem := range addr {
		addrRule = append(addrRule, addrItem)
	}

	var countRule []interface{}
	for _, countItem := range count {
		countRule = append(countRule, countItem)
	}
	var dailySubmitCountRule []interface{}
	for _, dailySubmitCountItem := range dailySubmitCount {
		dailySubmitCountRule = append(dailySubmitCountRule, dailySubmitCountItem)
	}

	logs, sub, err := _Witness.contract.WatchLogs(opts, "MerkleRootSubmitted", addrRule, countRule, dailySubmitCountRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(WitnessMerkleRootSubmitted)
				if err := _Witness.contract.UnpackLog(event, "MerkleRootSubmitted", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseMerkleRootSubmitted is a log parse operation binding the contract event 0x7c0db56049d8c21ac04eb9f10f3a12460a3cd42c97482ed65838b868f685a34d.
//
// Solidity: event MerkleRootSubmitted(address indexed addr, bytes32 merkleRoot, bytes32 merkleSumRoot, uint256 indexed count, uint256 indexed dailySubmitCount)
func (_Witness *WitnessFilterer) ParseMerkleRootSubmitted(log types.Log) (*WitnessMerkleRootSubmitted, error) {
	event := new(WitnessMerkleRootSubmitted)
	if err := _Witness.contract.UnpackLog(event, "MerkleRootSubmitted", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// WitnessMerkleRootThresholdChangedIterator is returned from FilterMerkleRootThresholdChanged and is used to iterate over the raw logs and unpacked data for MerkleRootThresholdChanged events raised by the Witness contract.
type WitnessMerkleRootThresholdChangedIterator struct {
	Event *WitnessMerkleRootThresholdChanged // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *WitnessMerkleRootThresholdChangedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(WitnessMerkleRootThresholdChanged)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(WitnessMerkleRootThresholdChanged)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *WitnessMerkleRootThresholdChangedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *WitnessMerkleRootThresholdChangedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// WitnessMerkleRootThresholdChanged represents a MerkleRootThresholdChanged event raised by the Witness contract.
type WitnessMerkleRootThresholdChanged struct {
	MerkleRootThreshold *big.Int
	Raw                 types.Log // Blockchain specific contextual infos
}

// FilterMerkleRootThresholdChanged is a free log retrieval operation binding the contract event 0xd43620d8f66512fa8246fc8c49d14f776a9938857d9e877639cc92a2955d5a4c.
//
// Solidity: event MerkleRootThresholdChanged(uint256 merkleRootThreshold)
func (_Witness *WitnessFilterer) FilterMerkleRootThresholdChanged(opts *bind.FilterOpts) (*WitnessMerkleRootThresholdChangedIterator, error) {

	logs, sub, err := _Witness.contract.FilterLogs(opts, "MerkleRootThresholdChanged")
	if err != nil {
		return nil, err
	}
	return &WitnessMerkleRootThresholdChangedIterator{contract: _Witness.contract, event: "MerkleRootThresholdChanged", logs: logs, sub: sub}, nil
}

// WatchMerkleRootThresholdChanged is a free log subscription operation binding the contract event 0xd43620d8f66512fa8246fc8c49d14f776a9938857d9e877639cc92a2955d5a4c.
//
// Solidity: event MerkleRootThresholdChanged(uint256 merkleRootThreshold)
func (_Witness *WitnessFilterer) WatchMerkleRootThresholdChanged(opts *bind.WatchOpts, sink chan<- *WitnessMerkleRootThresholdChanged) (event.Subscription, error) {

	logs, sub, err := _Witness.contract.WatchLogs(opts, "MerkleRootThresholdChanged")
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(WitnessMerkleRootThresholdChanged)
				if err := _Witness.contract.UnpackLog(event, "MerkleRootThresholdChanged", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseMerkleRootThresholdChanged is a log parse operation binding the contract event 0xd43620d8f66512fa8246fc8c49d14f776a9938857d9e877639cc92a2955d5a4c.
//
// Solidity: event MerkleRootThresholdChanged(uint256 merkleRootThreshold)
func (_Witness *WitnessFilterer) ParseMerkleRootThresholdChanged(log types.Log) (*WitnessMerkleRootThresholdChanged, error) {
	event := new(WitnessMerkleRootThresholdChanged)
	if err := _Witness.contract.UnpackLog(event, "MerkleRootThresholdChanged", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// WitnessOwnershipTransferredIterator is returned from FilterOwnershipTransferred and is used to iterate over the raw logs and unpacked data for OwnershipTransferred events raised by the Witness contract.
type WitnessOwnershipTransferredIterator struct {
	Event *WitnessOwnershipTransferred // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *WitnessOwnershipTransferredIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(WitnessOwnershipTransferred)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(WitnessOwnershipTransferred)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *WitnessOwnershipTransferredIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *WitnessOwnershipTransferredIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// WitnessOwnershipTransferred represents a OwnershipTransferred event raised by the Witness contract.
type WitnessOwnershipTransferred struct {
	PreviousOwner common.Address
	NewOwner      common.Address
	Raw           types.Log // Blockchain specific contextual infos
}

// FilterOwnershipTransferred is a free log retrieval operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Witness *WitnessFilterer) FilterOwnershipTransferred(opts *bind.FilterOpts, previousOwner []common.Address, newOwner []common.Address) (*WitnessOwnershipTransferredIterator, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _Witness.contract.FilterLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return &WitnessOwnershipTransferredIterator{contract: _Witness.contract, event: "OwnershipTransferred", logs: logs, sub: sub}, nil
}

// WatchOwnershipTransferred is a free log subscription operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Witness *WitnessFilterer) WatchOwnershipTransferred(opts *bind.WatchOpts, sink chan<- *WitnessOwnershipTransferred, previousOwner []common.Address, newOwner []common.Address) (event.Subscription, error) {

	var previousOwnerRule []interface{}
	for _, previousOwnerItem := range previousOwner {
		previousOwnerRule = append(previousOwnerRule, previousOwnerItem)
	}
	var newOwnerRule []interface{}
	for _, newOwnerItem := range newOwner {
		newOwnerRule = append(newOwnerRule, newOwnerItem)
	}

	logs, sub, err := _Witness.contract.WatchLogs(opts, "OwnershipTransferred", previousOwnerRule, newOwnerRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(WitnessOwnershipTransferred)
				if err := _Witness.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseOwnershipTransferred is a log parse operation binding the contract event 0x8be0079c531659141344cd1fd0a4f28419497f9722a3daafe3b4186f6b6457e0.
//
// Solidity: event OwnershipTransferred(address indexed previousOwner, address indexed newOwner)
func (_Witness *WitnessFilterer) ParseOwnershipTransferred(log types.Log) (*WitnessOwnershipTransferred, error) {
	event := new(WitnessOwnershipTransferred)
	if err := _Witness.contract.UnpackLog(event, "OwnershipTransferred", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}

// WitnessWitnessChangedIterator is returned from FilterWitnessChanged and is used to iterate over the raw logs and unpacked data for WitnessChanged events raised by the Witness contract.
type WitnessWitnessChangedIterator struct {
	Event *WitnessWitnessChanged // Event containing the contract specifics and raw log

	contract *bind.BoundContract // Generic contract to use for unpacking event data
	event    string              // Event name to use for unpacking event data

	logs chan types.Log        // Log channel receiving the found contract events
	sub  ethereum.Subscription // Subscription for errors, completion and termination
	done bool                  // Whether the subscription completed delivering logs
	fail error                 // Occurred error to stop iteration
}

// Next advances the iterator to the subsequent event, returning whether there
// are any more events found. In case of a retrieval or parsing error, false is
// returned and Error() can be queried for the exact failure.
func (it *WitnessWitnessChangedIterator) Next() bool {
	// If the iterator failed, stop iterating
	if it.fail != nil {
		return false
	}
	// If the iterator completed, deliver directly whatever's available
	if it.done {
		select {
		case log := <-it.logs:
			it.Event = new(WitnessWitnessChanged)
			if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
				it.fail = err
				return false
			}
			it.Event.Raw = log
			return true

		default:
			return false
		}
	}
	// Iterator still in progress, wait for either a data or an error event
	select {
	case log := <-it.logs:
		it.Event = new(WitnessWitnessChanged)
		if err := it.contract.UnpackLog(it.Event, it.event, log); err != nil {
			it.fail = err
			return false
		}
		it.Event.Raw = log
		return true

	case err := <-it.sub.Err():
		it.done = true
		it.fail = err
		return it.Next()
	}
}

// Error returns any retrieval or parsing error occurred during filtering.
func (it *WitnessWitnessChangedIterator) Error() error {
	return it.fail
}

// Close terminates the iteration process, releasing any pending underlying
// resources.
func (it *WitnessWitnessChangedIterator) Close() error {
	it.sub.Unsubscribe()
	return nil
}

// WitnessWitnessChanged represents a WitnessChanged event raised by the Witness contract.
type WitnessWitnessChanged struct {
	Addr  common.Address
	Ok    bool
	Count *big.Int
	Raw   types.Log // Blockchain specific contextual infos
}

// FilterWitnessChanged is a free log retrieval operation binding the contract event 0xfae38e0b0395412c5ac55a5b9231b2950defd7f1a4ba46b9a5317971e1aacab9.
//
// Solidity: event WitnessChanged(address indexed addr, bool indexed ok, uint256 indexed count)
func (_Witness *WitnessFilterer) FilterWitnessChanged(opts *bind.FilterOpts, addr []common.Address, ok []bool, count []*big.Int) (*WitnessWitnessChangedIterator, error) {

	var addrRule []interface{}
	for _, addrItem := range addr {
		addrRule = append(addrRule, addrItem)
	}
	var okRule []interface{}
	for _, okItem := range ok {
		okRule = append(okRule, okItem)
	}
	var countRule []interface{}
	for _, countItem := range count {
		countRule = append(countRule, countItem)
	}

	logs, sub, err := _Witness.contract.FilterLogs(opts, "WitnessChanged", addrRule, okRule, countRule)
	if err != nil {
		return nil, err
	}
	return &WitnessWitnessChangedIterator{contract: _Witness.contract, event: "WitnessChanged", logs: logs, sub: sub}, nil
}

// WatchWitnessChanged is a free log subscription operation binding the contract event 0xfae38e0b0395412c5ac55a5b9231b2950defd7f1a4ba46b9a5317971e1aacab9.
//
// Solidity: event WitnessChanged(address indexed addr, bool indexed ok, uint256 indexed count)
func (_Witness *WitnessFilterer) WatchWitnessChanged(opts *bind.WatchOpts, sink chan<- *WitnessWitnessChanged, addr []common.Address, ok []bool, count []*big.Int) (event.Subscription, error) {

	var addrRule []interface{}
	for _, addrItem := range addr {
		addrRule = append(addrRule, addrItem)
	}
	var okRule []interface{}
	for _, okItem := range ok {
		okRule = append(okRule, okItem)
	}
	var countRule []interface{}
	for _, countItem := range count {
		countRule = append(countRule, countItem)
	}

	logs, sub, err := _Witness.contract.WatchLogs(opts, "WitnessChanged", addrRule, okRule, countRule)
	if err != nil {
		return nil, err
	}
	return event.NewSubscription(func(quit <-chan struct{}) error {
		defer sub.Unsubscribe()
		for {
			select {
			case log := <-logs:
				// New log arrived, parse the event and forward to the user
				event := new(WitnessWitnessChanged)
				if err := _Witness.contract.UnpackLog(event, "WitnessChanged", log); err != nil {
					return err
				}
				event.Raw = log

				select {
				case sink <- event:
				case err := <-sub.Err():
					return err
				case <-quit:
					return nil
				}
			case err := <-sub.Err():
				return err
			case <-quit:
				return nil
			}
		}
	}), nil
}

// ParseWitnessChanged is a log parse operation binding the contract event 0xfae38e0b0395412c5ac55a5b9231b2950defd7f1a4ba46b9a5317971e1aacab9.
//
// Solidity: event WitnessChanged(address indexed addr, bool indexed ok, uint256 indexed count)
func (_Witness *WitnessFilterer) ParseWitnessChanged(log types.Log) (*WitnessWitnessChanged, error) {
	event := new(WitnessWitnessChanged)
	if err := _Witness.contract.UnpackLog(event, "WitnessChanged", log); err != nil {
		return nil, err
	}
	event.Raw = log
	return event, nil
}
